"""
    Xpress Insight Python package
    =============================

    This is an internal file of the 'xpressinsight' package. Do not import it directly.
    Set of Mosel keywords.

    This material is the confidential, proprietary, unpublished property
    of Fair Isaac Corporation.  Receipt or possession of this material
    does not convey rights to divulge, reproduce, use, or allow others
    to use it without the specific written authorization of Fair Isaac
    Corporation and use must conform strictly to the license agreement.

    Copyright (c) 2020-2024 Fair Isaac Corporation. All rights reserved.
"""

#
#
#
#
MOSEL_RESERVED_WORDS = [
    "and",
    "array",
    "as",
    "boolean",
    "break",
    "case",
    "constant",
    "count",
    "counter",
    "declarations",
    "div",
    "do",
    "dynamic",
    "elif",
    "else",
    "end",
    "evaluation",
    "false",
    "forall",
    "forward",
    "from",
    "function",
    "hashmap",
    "if",
    "imports",
    "in",
    "include",
    "initialisations",
    "initializations",
    "integer",
    "inter",
    "is",
    "is_binary",
    "is_continuous",
    "is_free",
    "is_integer",
    "is_partint",
    "is_semcont",
    "is_semint",
    "is_sos1",
    "is_sos2",
    "linctr",
    "list",
    "max",
    "min",
    "mod",
    "model",
    "mpvar",
    "namespace",
    "next",
    "not",
    "nsgroup",
    "nssearch",
    "of",
    "options",
    "or",
    "package",
    "parameters",
    "procedure",
    "public",
    "prod",
    "range",
    "real",
    "record",
    "repeat",
    "requirements",
    "return",
    "set",
    "shared",
    "string",
    "sum",
    "then",
    "to",
    "true",
    "union",
    "until",
    "uses",
    "version",
    "while",
    "with"
]

#
#
#
APPRUNNER_GLOBAL_DICTIONARY = [
    '0sqlpar',
    'abs',
    'addcut',
    'addcuts',
    'addmipsol',
    'addmonths',
    'addnode',
    'any',
    'apprunner',
    'arccos',
    'arcsin',
    'arctan',
    'asproc',
    'assert',
    'basis',
    'basisstability',
    'bitflip',
    'bitneg',
    'bitset',
    'bitshift',
    'bittest',
    'bitval',
    'boolean',
    'boolvar',
    'calcsolinfo',
    'callfunc',
    'callfunclsa',
    'callproc',
    'callproclsa',
    'canceltimer',
    'catch',
    'ceil',
    'clearaliases',
    'clearerror',
    'clearinitvals',
    'clearmipdir',
    'clearmodcut',
    'clsarrsrtndx',
    'command',
    'compare',
    'compareic',
    'compile',
    'connect',
    'copynode',
    'copysoltoinit',
    'copytext',
    'cos',
    'create',
    'crossoverlpsol',
    'CT_BIN',
    'CT_CONT',
    'CT_EQ',
    'CT_FREE',
    'CT_GEQ',
    'CT_INT',
    'CT_LEQ',
    'CT_PINT',
    'CT_RNG',
    'CT_SEC',
    'CT_SINT',
    'CT_SOS1',
    'CT_SOS2',
    'CT_UNB',
    'currentdate',
    'currenttime',
    'cutelt',
    'cutfirst',
    'cuthead',
    'cutlast',
    'cuttail',
    'cuttext',
    'datablock',
    'date',
    'datetime',
    'debugarchive',
    'debugarchiveadd',
    'debugarchivecreate',
    'debugarchiveerror',
    'debugarchiveok',
    'defdelayedrows',
    'defsecurevecs',
    'delattr',
    'delcell',
    'delcookies',
    'delcuts',
    'delnode',
    'deltext',
    'detach',
    'disconnect',
    'dmp',
    'dmpcompinst',
    'dmpcompinstrev',
    'dmpcomponent',
    'dmphttpdel',
    'dmphttpget',
    'dmphttphead',
    'dmphttppatch',
    'dmphttppost',
    'dmphttpput',
    'dmphttprequest',
    'dmpinitcomp',
    'dmpinitdatapipelines',
    'dmpinitjson',
    'dmpinitmanager',
    'dmpiniturl',
    'dmpinitwebservice',
    'dmpresource',
    'DMP_ACCESS_DENIED',
    'DMP_AUTH_ERROR',
    'DMP_ENV_DESIGN',
    'DMP_ENV_PRODUCTION',
    'DMP_ENV_STAGING',
    'DMP_IO_ERROR',
    'DMP_NOT_FOUND',
    'DMP_OK',
    'DMP_PARSE_ERROR',
    'DMP_RESOURCE_COMPONENT',
    'DMP_RESOURCE_DATA_PIPELINES',
    'DMP_RESOURCE_DMP_MANAGER',
    'DMP_RESOURCE_SERVICE',
    'DMP_RESOURCE_UNINITIALIZED',
    'DMP_RESOURCE_USER',
    'DMP_RESOURCE_WEBSERVICE',
    'DMP_TOKEN_TYPE_BEARER',
    'DMP_TOKEN_TYPE_JWT',
    'dropcuts',
    'dropnextevent',
    'dumpcallstack',
    'endswith',
    'EPROP_CONST',
    'EPROP_DENSE',
    'EPROP_DYNAMIC',
    'EPROP_GENSET',
    'EPROP_HASHMAP',
    'EPROP_PRIV',
    'EPROP_PUBLIC',
    'EPROP_RANGE',
    'EPROP_SPARSE',
    'EPROP_VAR',
    'EP_HEX',
    'EP_MAX',
    'EP_MIN',
    'EP_MPS',
    'EP_STRIP',
    'erase',
    'erf',
    'erfc',
    'estimatemarginals',
    'Event',
    'EVENT_END',
    'EVENT_HTTPEND',
    'EVENT_HTTPNEW',
    'EVENT_TIMER',
    'Exception',
    'Exception_set',
    'exists',
    'exit',
    'exp',
    'expandpath',
    'exportprob',
    'fclose',
    'fcopy',
    'fdelete',
    'fflush',
    'finalise',
    'finalize',
    'findcookie',
    'findfield',
    'findfiles',
    'findfirst',
    'findident',
    'findlast',
    'findtext',
    'findxsrvs',
    'fixglobal',
    'fixmipentities',
    'floor',
    'flushmsgq',
    'fmax',
    'fmin',
    'fmove',
    'fopen',
    'formattext',
    'fselect',
    'fskipline',
    'fwrite',
    'fwriteln',
    'fwriteln_',
    'fwrite_',
    'F_APPEND',
    'F_BINARY',
    'F_DELCLOSE',
    'F_ERROR',
    'F_INPUT',
    'F_IOERR',
    'F_LINBUF',
    'F_OUTPUT',
    'F_SILENT',
    'F_TEXT',
    'getabspath',
    'getabstol',
    'getact',
    'getaliases',
    'getallfields',
    'getallidents',
    'getallparams',
    'getalternateinstance',
    'getannidents',
    'getannotations',
    'getarrval',
    'getasnumber',
    'getattr',
    'getbanner',
    'getboolattr',
    'getboolvalue',
    'getbstat',
    'getchar',
    'getclass',
    'getcnlist',
    'getcode',
    'getcoeff',
    'getcoeffs',
    'getcomment',
    'getcomponentid',
    'getcomponentinstanceid',
    'getcomponentprototyperevisionid',
    'getcomponentrevisionid',
    'getcomputeallowed',
    'getcontainerproviderdata',
    'getcontainerproviderid',
    'getcontainerserviceproviderid',
    'getcontext',
    'getcplist',
    'getcreatedby',
    'getcreatedts',
    'getcurrentrevision',
    'getcwd',
    'getdate',
    'getday',
    'getdaynum',
    'getdays',
    'getdescription',
    'getdirsep',
    'getdmpauthfunc',
    'getdmpcompid',
    'getdmpcomponents',
    'getdmpcompurl',
    'getdmplifecycleenv',
    'getdmpsolid',
    'getdsoparam',
    'getdsoprop',
    'getdsopropnum',
    'getdual',
    'getdualray',
    'getelt',
    'geteltype',
    'getencoding',
    'getendparse',
    'getengineprofile',
    'getenginetype',
    'getengineversion',
    'getenv',
    'getenvid',
    'getenvs',
    'getexitcode',
    'getfid',
    'getfieldname',
    'getfieldtype',
    'getfieldval',
    'getfirst',
    'getfirstattr',
    'getfirstchild',
    'getflstat',
    'getfname',
    'getfromcomponentinstancerevisionid',
    'getfromgid',
    'getfromid',
    'getfromuid',
    'getfsize',
    'getfstat',
    'getftime',
    'getgid',
    'gethead',
    'gethealthcheckrelativeurl',
    'gethostalias',
    'gethour',
    'gethspace',
    'getid',
    'getiis',
    'getiissense',
    'getiistype',
    'getindentmode',
    'getindentskip',
    'getindices',
    'getindictype',
    'getinfcause',
    'getinfeas',
    'getinstance',
    'getinstances',
    'getintattr',
    'getinternalurl',
    'getintvalue',
    'getkeyprefix',
    'getlabel',
    'getlast',
    'getlastchild',
    'getlasterror',
    'getlastmodifiedby',
    'getlastmodifiedts',
    'getlb',
    'getlcmstate',
    'getlcmstatedescription',
    'getlct',
    'getleft',
    'getlinelen',
    'getloadedlinctrs',
    'getloadedmpvars',
    'getmatcoeff',
    'getmatstat',
    'getmaxnodes',
    'getminute',
    'getmodprop',
    'getmodpropnum',
    'getmonth',
    'getmsec',
    'getmsg',
    'getmultidatacenterinstance',
    'getname',
    'getnbargs',
    'getnbdim',
    'getnext',
    'getnextevent',
    'getnode',
    'getnodes',
    'getobjintattr',
    'getobjrealattr',
    'getobjval',
    'getoserrmsg',
    'getoserror',
    'getparam',
    'getparent',
    'getparentinstanceid',
    'getpathsep',
    'getpftoken',
    'getpftokenexpiry',
    'getprimalray',
    'getpriority',
    'getprobstat',
    'getproxyurl',
    'getqtype',
    'getrange',
    'getrcost',
    'getreadcnt',
    'getrealattr',
    'getrealvalue',
    'getregion',
    'getrelgap',
    'getreltol',
    'getresourcetype',
    'getrettype',
    'getreverse',
    'getright',
    'getrmtid',
    'getrowversion',
    'getscale',
    'getscalecount',
    'getsecond',
    'getsensrng',
    'getsepchar',
    'getsignature',
    'getsize',
    'getslack',
    'getsol',
    'getstandalone',
    'getstart',
    'getstate',
    'getstatedescription',
    'getstatus',
    'getstrattr',
    'getstruct',
    'getstrvalue',
    'getsucc',
    'getsysinfo',
    'getsysstat',
    'getsystemdata',
    'gettail',
    'gettime',
    'gettimer',
    'gettimestamp',
    'gettmpdir',
    'gettrim',
    'getttl',
    'gettype',
    'gettypeid',
    'getub',
    'getuid',
    'geturl',
    'getvalue',
    'getvar',
    'getvars',
    'getversion',
    'getvspace',
    'getweekday',
    'getweight',
    'getxmlversion',
    'gety',
    'getyear',
    'get_insightcontext2',
    'hasfeature',
    'httpcancel',
    'httpdel',
    'httpget',
    'httpgetheader',
    'httphead',
    'httppatch',
    'httppending',
    'httppost',
    'httpput',
    'httpqueueinfo',
    'httpreason',
    'httpreply',
    'httpreplycode',
    'httpreplyjson',
    'httpreqcipher',
    'httpreqconstat',
    'httpreqcookies',
    'httpreqfile',
    'httpreqfrom',
    'httpreqfroms',
    'httpreqheader',
    'httpreqlabel',
    'httpreqlabels',
    'httpreqpop',
    'httpreqpush',
    'httpreqpushlim',
    'httpreqstat',
    'httpreqtype',
    'httpstartsrv',
    'httpstopsrv',
    'HTTP_ACCEPTED',
    'HTTP_BAD_REQUEST',
    'HTTP_CLTAUTH',
    'HTTP_CREATED',
    'HTTP_DELETE',
    'HTTP_FORBIDDEN',
    'HTTP_GET',
    'HTTP_HEAD',
    'HTTP_INDENT',
    'HTTP_METHOD_NOT_ALLOWED',
    'HTTP_NOT_ACCEPTABLE',
    'HTTP_NOT_FOUND',
    'HTTP_NO_CONTENT',
    'HTTP_OK',
    'HTTP_PATCH',
    'HTTP_PAYMENT_REQUIRED',
    'HTTP_POST',
    'HTTP_PROXY_AUTHENTICATION_REQUIRED',
    'HTTP_PUT',
    'HTTP_REQUEST_TIMEOUT',
    'HTTP_RESET_CONTENT',
    'HTTP_SKIP_EMPTYCOL',
    'HTTP_SKIP_EMPTYUNION',
    'HTTP_SSL',
    'HTTP_SSLONLY',
    'HTTP_UNAUTHORIZED',
    'implies',
    'indicator',
    'INFINITY',
    'iniobuffer',
    'inititer',
    'inserttext',
    'insightadditeminfo',
    'insightappattachinfo',
    'insightappmessageresponse',
    'insightattachment',
    'insightattachmentrules',
    'insightattachmenttag',
    'insightattachstatus',
    'insightcapture',
    'insightcleariteminfos',
    'insightcontext',
    'insightcontext2',
    'insightdeletescenattach',
    'insightdispatch',
    'insightdmpcontext',
    'insightdmpcontext2',
    'insightgetappattach',
    'insightgetappid',
    'insightgetappname',
    'insightgetattachbytag',
    'insightgetattachrules',
    'insightgetcontext',
    'insightgetiteminfo',
    'insightgetiteminfos',
    'insightgetmetrics',
    'insightgetmode',
    'insightgetmsg',
    'insightgetresourcelimits',
    'insightgetscenattach',
    'insightgetscendataversion',
    'insightgetschema',
    'insightgetsoldb',
    'insightgetsoldbconnstr',
    'insightgetuserid',
    'insightgetusername',
    'insightgetversion',
    'insightiteminfo',
    'insightlistappattach',
    'insightlistappattachbytag',
    'insightlistattachtags',
    'insightlistscenattach',
    'insightlistscenattachbytag',
    'insightmaximize',
    'insightminimize',
    'insightpopulate',
    'insightpreparectrs',
    'insightputmsg',
    'insightputscenattach',
    'insightrenamescenattach',
    'insightresetprogress',
    'insightresourcelimits',
    'insightresultsready',
    'insightscenattachinfo',
    'insightschemaentity',
    'insightsendmessage',
    'insightsendmessageandwait',
    'insightsendprogress',
    'insightsetappid',
    'insightsetappname',
    'insightsetattachrules',
    'insightsetattachtags',
    'insightsetcbpopulate',
    'insightsetcontext',
    'insightsetmode',
    'insightsetresourcelimits',
    'insightsetscenattachdesc',
    'insightsetscenattachhidden',
    'insightsetscenattachtags',
    'insightsetscendataversion',
    'insightsetsoldb',
    'insightsetsubmitmetricerr',
    'insightsettestappattachdir',
    'insightsettestscenattachdir',
    'insightsetuserid',
    'insightsetusername',
    'insightsetversion',
    'insightsoldb',
    'insightsolveoptions',
    'insightsubmitmetric',
    'insightsubmitmetricerr',
    'insightupdate',
    'insightupdateprogress',
    'INSIGHT_ATTACH_ALREADY_EXISTS',
    'INSIGHT_ATTACH_INVALID_DESCRIPTION',
    'INSIGHT_ATTACH_INVALID_FILENAME',
    'INSIGHT_ATTACH_INVALID_TAGS',
    'INSIGHT_ATTACH_IN_PROGRESS',
    'INSIGHT_ATTACH_NOT_FOUND',
    'INSIGHT_ATTACH_OK',
    'INSIGHT_ATTACH_RUNTIME_ERROR',
    'INSIGHT_ATTACH_SEVERAL_FOUND',
    'INSIGHT_ATTACH_TOO_LARGE',
    'INSIGHT_ATTACH_TOO_MANY',
    'INSIGHT_DEFAULT_NODE',
    'INSIGHT_ENTITY_STRUCT_ARRAY',
    'INSIGHT_ENTITY_STRUCT_SCALAR',
    'INSIGHT_ENTITY_STRUCT_SET',
    'INSIGHT_ENTITY_TYPE_BOOL',
    'INSIGHT_ENTITY_TYPE_INT',
    'INSIGHT_ENTITY_TYPE_LINCTR',
    'INSIGHT_ENTITY_TYPE_MODEL',
    'INSIGHT_ENTITY_TYPE_MPVAR',
    'INSIGHT_ENTITY_TYPE_REAL',
    'INSIGHT_ENTITY_TYPE_STRING',
    'INSIGHT_GAP',
    'INSIGHT_MAXIMIZE',
    'insight_message_payload',
    'INSIGHT_MINIMIZE',
    'INSIGHT_MODE_LOAD',
    'INSIGHT_MODE_NONE',
    'INSIGHT_MODE_RUN',
    'INSIGHT_NUMSOLS',
    'INSIGHT_OBJSENSE',
    'INSIGHT_OBJVAL',
    'insight_on_gap_notify',
    'integer',
    'IOERR_IN',
    'IOERR_OUT',
    'isdefined',
    'isdmp',
    'isdynamic',
    'iseof',
    'isfinite',
    'ishidden',
    'isiisvalid',
    'isinf',
    'isintegral',
    'isnan',
    'isodd',
    'isqueueempty',
    'isvalid',
    'ITER_BOUND',
    'ITER_DENSE',
    'ITER_DONE',
    'ITER_FREE',
    'ITER_READY',
    'ITER_SPARSE',
    'jointext',
    'jsonload',
    'jsonparse',
    'jsonread',
    'jsonsave',
    'jsonwrite',
    'JSON_FCT_BOOL',
    'JSON_FCT_CLOSE_ARR',
    'JSON_FCT_CLOSE_OBJ',
    'JSON_FCT_NULL',
    'JSON_FCT_NUM',
    'JSON_FCT_OPEN_ARR',
    'JSON_FCT_OPEN_OBJ',
    'JSON_FCT_TEXT',
    'kill',
    'linctr',
    'ln',
    'load',
    'loadbasis',
    'loadcookies',
    'loadcuts',
    'loadlpsol',
    'loadmipsol',
    'loadprob',
    'localsetparam',
    'log',
    'logctr',
    'makedir',
    'makepath',
    'makesos1',
    'makesos2',
    'maximise',
    'maximize',
    'maxlist',
    'MAX_INT',
    'MAX_REAL',
    'memoryuse',
    'minimise',
    'minimize',
    'minlist',
    'mksetcookie',
    'mmarrow',
    'mmhttp',
    'mminsight',
    'mminsightannotations',
    'mminsight_scratchdir',
    'mmjobs',
    'mmnl',
    'mmodbc',
    'mmreflect',
    'mmssl',
    'mmsystem',
    'mmxml',
    'mmxprs',
    'Model',
    'mpproblem',
    'mpsol',
    'mpvar',
    'msgdigest',
    'msgsign',
    'msgverify',
    'M_E',
    'M_PI',
    'NAN',
    'newmuid',
    'newtar',
    'newzip',
    'nextcell',
    'nextfield',
    'nil',
    'nlctr',
    'nullevent',
    'objconfig',
    'openpipe',
    'parquetload',
    'parquetloadbyname',
    'parquetsave',
    'parquetsavebyname',
    'parseBool',
    'parsectx',
    'parseextn',
    'parseint',
    'parseReal',
    'parsereal',
    'parsetext',
    'pastetext',
    'pathmatch',
    'pathsplit',
    'peeknextevent',
    'pipeflush',
    'pipenotify',
    'postsolve',
    'procedure',
    'PROP_COMPAT',
    'PROP_DATE',
    'PROP_ID',
    'PROP_NAME',
    'PROP_NBBIM',
    'PROP_PATH',
    'PROP_SIZE',
    'PROP_SYSCOM',
    'PROP_UNAME',
    'PROP_USRCOM',
    'PROP_VERSION',
    'publish',
    'pwlin',
    'pws',
    'qsort',
    'quote',
    'random',
    'read',
    'readbasis',
    'readdirs',
    'readlink',
    'readln',
    'readsol',
    'readtextline',
    'real',
    'refinemipsol',
    'reflecterror',
    'regmatch',
    'regreplace',
    'REG_EXTENDED',
    'REG_ICASE',
    'REG_NEWLINE',
    'REG_NOTBOL',
    'REG_NOTEOL',
    'REG_ONCE',
    'rejectintsol',
    'removedir',
    'removefiles',
    'repairinfeas',
    'reset',
    'resetbasis',
    'resetiis',
    'resetmodpar',
    'resetsol',
    'restoreparam',
    'reverse',
    'round',
    'RSAfingerprint',
    'RSAgenkey',
    'RSAgetkeysize',
    'RSAisprivate',
    'RSAloadkey',
    'RSAprivdecrypt',
    'RSAprivencrypt',
    'RSApubdecrypt',
    'RSApubencrypt',
    'RSAsavekey',
    'RT_DETACHED',
    'RT_ERROR',
    'RT_FDCLOSED',
    'RT_IOERR',
    'RT_LICERR',
    'RT_MATHERR',
    'RT_NOTINIT',
    'RT_NULL',
    'RT_OK',
    'RT_RUNNING',
    'RT_STOP',
    'run',
    's3',
    's3bucket',
    's3delobject',
    's3getlasterror',
    's3getobject',
    's3getobjectmetadata',
    's3getobjecttagging',
    's3init',
    's3listobjects',
    's3newtag',
    's3objectexists',
    's3objectinfo',
    's3objectlist',
    's3objectmetadata',
    's3owner',
    's3putobject',
    's3setobjecttagging',
    's3solutiondata',
    's3solutionrevision',
    's3status',
    's3tag',
    's3usermetadatakeys',
    'S3_ACCESS_DENIED',
    'S3_CONNECTION_ERROR',
    'S3_DMP_DESIGN',
    'S3_DMP_PRODUCTION',
    'S3_DMP_SOLUTIONDATA',
    'S3_DMP_SOLUTIONREVISION',
    'S3_DMP_STAGING',
    'S3_DMP_TENANTSHARED',
    'S3_IO_ERROR',
    'S3_NOT_FOUND',
    'S3_OK',
    'S3_PARSE_ERROR',
    'S3_SERVICE_ERROR',
    'save',
    'savebasis',
    'savecookies',
    'savemipsol',
    'savesol',
    'savestate',
    'selectsol',
    'send',
    'setabspath',
    'setabstol',
    'setaccesskeyid',
    'setalternateinstance',
    'setarchconsistency',
    'setarrval',
    'setattr',
    'setbstat',
    'setcallback',
    'setcbcutoff',
    'setchar',
    'setcoeff',
    'setcomment',
    'setcomponentid',
    'setcomponentinstanceid',
    'setcomponentprototyperevisionid',
    'setcomponentrevisionid',
    'setcomputeallowed',
    'setcontainerproviderdata',
    'setcontainerproviderid',
    'setcontainerserviceproviderid',
    'setcontext',
    'setcontrol',
    'setcookie',
    'setcreatedby',
    'setcreatedts',
    'setcurrentrevision',
    'setdate',
    'setday',
    'setdefstream',
    'setdescription',
    'setdsoparam',
    'setencoding',
    'setendparse',
    'setengineprofile',
    'setenginetype',
    'setengineversion',
    'setenv',
    'setenvid',
    'setenvs',
    'seterror',
    'setfieldval',
    'setfromcomponentinstancerevisionid',
    'setgid',
    'setgndata',
    'sethealthcheckrelativeurl',
    'sethidden',
    'sethostalias',
    'sethour',
    'sethspace',
    'setid',
    'setindentmode',
    'setindentskip',
    'setindices',
    'setinitval',
    'setinstances',
    'setinternalurl',
    'setioerr',
    'setkeyprefix',
    'setlabel',
    'setlastmodifiedby',
    'setlastmodifiedts',
    'setlb',
    'setlcmstate',
    'setlcmstatedescription',
    'setlinelen',
    'setmatcoeff',
    'setmatherr',
    'setmaxnodes',
    'setminute',
    'setmipdir',
    'setmodcut',
    'setmodpar',
    'setmonth',
    'setmsec',
    'setmultidatacenterinstance',
    'setname',
    'setoserror',
    'setparam',
    'setparentinstanceid',
    'setpftoken',
    'setpftokenexpiry',
    'setpriority',
    'setproxyurl',
    'setqtype',
    'setrandseed',
    'setrange',
    'setrefreshfunc',
    'setregion',
    'setreltol',
    'setrowversion',
    'setscalecount',
    'setsecond',
    'setsecretkey',
    'setsepchar',
    'setsessiontoken',
    'setsol',
    'setsse',
    'setssecontext',
    'setssekmskeyid',
    'setstandalone',
    'setstart',
    'setstate',
    'setstatedescription',
    'setsucc',
    'setsystemdata',
    'settime',
    'settimer',
    'settimestamp',
    'settrim',
    'setttl',
    'settype',
    'setub',
    'setucbdata',
    'setuid',
    'seturl',
    'setvalue',
    'setversion',
    'setvspace',
    'setweight',
    'setworkdir',
    'setxmlversion',
    'setyear',
    'sign',
    'sin',
    'sleep',
    'splithead',
    'splittail',
    'splittext',
    'SQLcolumns',
    'SQLcommit',
    'SQLconnect',
    'SQLdataframe',
    'SQLdisconnect',
    'SQLexecute',
    'SQLgetiparam',
    'SQLgetrparam',
    'SQLgetsparam',
    'SQLindices',
    'SQLparam',
    'SQLprimarykeys',
    'SQLreadinteger',
    'SQLreadreal',
    'SQLreadstring',
    'SQLrollback',
    'SQLtables',
    'SQLupdate',
    'sqrt',
    'sslivsize',
    'sslkeysize',
    'sslmdsize',
    'sslrandom',
    'sslrandomdata',
    'SSL_OK',
    'startswith',
    'stop',
    'stopoptimise',
    'stopoptimize',
    'storecut',
    'storecuts',
    'strfmt',
    'string',
    'STRUCT_ARRAY',
    'STRUCT_CONST',
    'STRUCT_LIST',
    'STRUCT_NATTYPE',
    'STRUCT_NIL',
    'STRUCT_PROBLEM',
    'STRUCT_RECORD',
    'STRUCT_REF',
    'STRUCT_ROUTINE',
    'STRUCT_SET',
    'STRUCT_UNION',
    'STRUCT_USRTYPE',
    'substr',
    'symlink',
    'system',
    'SYS_ARCH',
    'SYS_DIR',
    'SYS_DIRONLY',
    'SYS_DOWN',
    'SYS_EXEC',
    'SYS_EXTN',
    'SYS_FLAT',
    'SYS_FNAME',
    'SYS_FTIM_ACC',
    'SYS_FTIM_MOD',
    'SYS_LEFT',
    'SYS_LNK',
    'SYS_MOD',
    'SYS_NAME',
    'SYS_NODE',
    'SYS_NODIR',
    'SYS_NOFAIL',
    'SYS_NOSORT',
    'SYS_NOW',
    'SYS_OTH',
    'SYS_OVERWRT',
    'SYS_PID',
    'SYS_PROC',
    'SYS_RAM',
    'SYS_READ',
    'SYS_RECURS',
    'SYS_REG',
    'SYS_REL',
    'SYS_REVORD',
    'SYS_RIGHT',
    'SYS_TYP',
    'SYS_UP',
    'SYS_VER',
    'SYS_VERB',
    'SYS_WRITE',
    'tan',
    'tarlist',
    'tcpping',
    'testattr',
    'testtype',
    'text',
    'textarea',
    'textfmt',
    'time',
    'timestamp',
    'tolower',
    'toupper',
    'trim',
    'try',
    'unload',
    'unloadprob',
    'unpublish',
    'untar',
    'unzip',
    'urlencode',
    'uselastbarsol',
    'versionnum',
    'versionstr',
    'wait',
    'waitexpired',
    'waitfor',
    'waitforend',
    'WAIT_EXACT',
    'WAIT_GID',
    'WAIT_ID',
    'WAIT_INFINITE',
    'WAIT_KEEP',
    'WAIT_UID',
    'write',
    'writebasis',
    'writedirs',
    'writeln',
    'writeln_',
    'writeprob',
    'writesol',
    'write_',
    'x509check',
    'x509getinfo',
    'x509newcrt',
    'xmlattr',
    'xmldecode',
    'xmldoc',
    'xmlencode',
    'xmlparse',
    'XML_ATTR',
    'XML_AUTO',
    'XML_CDATA',
    'XML_COM',
    'XML_DATA',
    'XML_ELT',
    'XML_FCT_CDATA',
    'XML_FCT_CLOSE_ELT',
    'XML_FCT_COM',
    'XML_FCT_DATA',
    'XML_FCT_DECL',
    'XML_FCT_OPEN_ELT',
    'XML_FCT_PINST',
    'XML_FCT_TXT',
    'XML_FIRST',
    'XML_FIRSTCHILD',
    'XML_LAST',
    'XML_LASTCHILD',
    'XML_MANUAL',
    'XML_NEXT',
    'XML_NONE',
    'XML_PINST',
    'XML_TXT',
    'xor',
    'xpri_addcb_write_presolve_mps',
    'xpri_add_submodel_mpx',
    'xpri_append_odbc_conn_str_param',
    'xpri_beforeload',
    'xpri_beforesolve',
    'xpri_capture',
    'xpri_captureprogress',
    'xpri_checkforannotation',
    'xpri_checkforannotation_everywhere',
    'xpri_cleanupdebugarchives',
    'xpri_clearlastjobrequesterror',
    'xpri_echorequest',
    'xpri_exportprob',
    'xpri_getattachchanges',
    'xpri_getattachchanges_EMPTY_CHANGES_LIST',
    'xpri_getattachchanges_scratch',
    'xpri_getexecutionmode',
    'xpri_getlastjobrequesterror',
    'xpri_getlastjobrequesterrortype',
    'xpri_getmode',
    'xpri_getschemaentity',
    'xpri_getschemaentitynames',
    'xpri_getusername',
    'xpri_get_matrix_explorer_folder',
    'xpri_get_next_matrix_explorer_name',
    'xpri_isdsoloaded',
    'xpri_isnonlinear',
    'xpri_isscenarioinstance',
    'xpri_is_fnlset',
    'XPRI_JOBREQUEST_ERRORTYPE_COMMS',
    'XPRI_JOBREQUEST_ERRORTYPE_NONE',
    'XPRI_JOBREQUEST_ERRORTYPE_SERVER',
    'xpri_loadattachrules',
    'xpri_log',
    'xpri_logwarning',
    'xpri_makejobrequest',
    'xpri_makejobrequest_serverResponseText',
    'xpri_maketempfile',
    'xpri_matrix_explorer_put_attach',
    'xpri_overrideparams',
    'xpri_package_initialized',
    'xpri_populate',
    'xpri_post_optimize',
    'xpri_prepare_ctrs',
    'xpri_pre_optimize',
    'xpri_raiseerror',
    'xpri_raiseioerror',
    'xpri_rangelist_assign_unused',
    'xpri_rangelist_contains',
    'xpri_rangelist_from_values',
    'xpri_rangelist_merge',
    'xpri_removecb_write_presolve_mps',
    'xpri_resetrelgapnotify',
    'xpri_reset_progress',
    'xpri_resolverepopath',
    'xpri_results_ready',
    'xpri_setcbpopulate',
    'xpri_setdsoparam',
    'xpri_setpackageversion',
    'xpri_set_matrix_explorer_folder',
    'xpri_update',
    'xpri_updatedebugarchive',
    'xpri_update_progress',
    'xpri_writeattachrules',
    'xpri_writeiis',
    'xpri_writesinglefiletagscenattach',
    'XPRSbeginlicensing',
    'XPRSendlicensing',
    'XPRSfree',
    'XPRSgetdaysleft',
    'XPRSgetlicerrmsg',
    'XPRSinit',
    'XPRSlicense',
    'xprsmemoryuse',
    'xprs_addctr',
    'xprs_addindic',
    'XPRS_ALG_BARRIER',
    'XPRS_ALG_DEFAULT',
    'XPRS_ALG_DUAL',
    'XPRS_ALG_PRIMAL',
    'XPRS_ALLOW_COMPUTE_ALWAYS',
    'XPRS_ALLOW_COMPUTE_DEFAULT',
    'XPRS_ALLOW_COMPUTE_NEVER',
    'XPRS_BAR',
    'XPRS_BAR_DEFAULT',
    'XPRS_BAR_MIN_DEGREE',
    'XPRS_BAR_MIN_LOCAL_FILL',
    'XPRS_BAR_NESTED_DISSECTION',
    'XPRS_BR',
    'XPRS_CB_AFTEROBJECTIVE',
    'XPRS_CB_BARITER',
    'XPRS_CB_BARLOG',
    'XPRS_CB_BEFORELOAD',
    'XPRS_CB_BEFOREOBJECTIVE',
    'XPRS_CB_BEFORESOLVE',
    'XPRS_CB_BL',
    'XPRS_CB_CHECKTIME',
    'XPRS_CB_CHGBRANCH',
    'XPRS_CB_CHGNODE',
    'XPRS_CB_CM',
    'XPRS_CB_COMPUTERESTART',
    'XPRS_CB_CUTLOG',
    'XPRS_CB_CUTMGR',
    'XPRS_CB_DESTROYMT',
    'XPRS_CB_GAPNOTIFY',
    'XPRS_CB_GL',
    'XPRS_CB_GLOBALLOG',
    'XPRS_CB_IL',
    'XPRS_CB_INFNODE',
    'XPRS_CB_INTSOL',
    'XPRS_CB_LPLOG',
    'XPRS_CB_MIPLOG',
    'XPRS_CB_MIPTHREAD',
    'XPRS_CB_NEWNODE',
    'XPRS_CB_NODECUTOFF',
    'XPRS_CB_NODELPSOLVED',
    'XPRS_CB_OPTNODE',
    'XPRS_CB_PREINTSOL',
    'XPRS_CB_PRENODE',
    'XPRS_CB_PRESOLVE',
    'XPRS_CB_SOLNOTIFY',
    'XPRS_CB_UCB',
    'XPRS_CB_UCN',
    'XPRS_CB_UIN',
    'XPRS_CB_UIS',
    'XPRS_CB_UON',
    'XPRS_CB_UPN',
    'XPRS_CB_USN',
    'XPRS_CM_ALL',
    'XPRS_CM_BALL',
    'XPRS_CM_BANY',
    'XPRS_CM_NUM',
    'XPRS_CONT',
    'XPRS_COREPB',
    'XPRS_DN',
    'XPRS_DUAL',
    'XPRS_ENUM',
    'XPRS_GN_ABSBOUNDTARGET',
    'XPRS_GN_ABSOBJTARGET',
    'XPRS_GN_ABSTARGET',
    'XPRS_GN_RELTARGET',
    'XPRS_IIS_BIN',
    'XPRS_IIS_EQ',
    'XPRS_IIS_GEQ',
    'XPRS_IIS_INDIC',
    'XPRS_IIS_INT',
    'XPRS_IIS_LEQ',
    'XPRS_IIS_NONE',
    'XPRS_IIS_PINT',
    'XPRS_IIS_RNG',
    'XPRS_IIS_SEC',
    'XPRS_IIS_SINT',
    'XPRS_IIS_SOS1',
    'XPRS_IIS_SOS2',
    'XPRS_INF',
    'XPRS_LBND',
    'XPRS_LCOST',
    'XPRS_LIN',
    'XPRS_LOACT',
    'XPRS_LOCAL',
    'XPRS_LPSTOP',
    'XPRS_LP_CUTOFF',
    'XPRS_LP_CUTOFF_IN_DUAL',
    'XPRS_LP_INFEAS',
    'XPRS_LP_NONCONVEX',
    'XPRS_LP_OPTIMAL',
    'XPRS_LP_UNBOUNDED',
    'XPRS_LP_UNFINISHED',
    'XPRS_LP_UNSOLVED',
    'XPRS_LP_UNSTARTED',
    'XPRS_MIP_INFEAS',
    'XPRS_MIP_LP_NOT_OPTIMAL',
    'XPRS_MIP_LP_OPTIMAL',
    'XPRS_MIP_NOT_LOADED',
    'XPRS_MIP_NO_SOL_FOUND',
    'XPRS_MIP_OPTIMAL',
    'XPRS_MIP_SOLUTION',
    'XPRS_MIP_UNBOUNDED',
    'XPRS_NET',
    'XPRS_NOMINAL',
    'XPRS_OPT',
    'XPRS_OTH',
    'XPRS_PD',
    'XPRS_PR',
    'XPRS_PRI',
    'XPRS_PU',
    'XPRS_SOLINFO_ABSPRIMALINFEAS',
    'XPRS_SOLINFO_MAXMIPFRACTIONAL',
    'XPRS_SOLINFO_RELPRIMALINFEAS',
    'XPRS_SOLSTATUS_FEASIBLE',
    'XPRS_SOLSTATUS_INFEASIBLE',
    'XPRS_SOLSTATUS_NOTFOUND',
    'XPRS_SOLSTATUS_OPTIMAL',
    'XPRS_SOLSTATUS_UNBOUNDED',
    'XPRS_SOLVESTATUS_COMPLETED',
    'XPRS_SOLVESTATUS_FAILED',
    'XPRS_SOLVESTATUS_STOPPED',
    'XPRS_SOLVESTATUS_UNSTARTED',
    'XPRS_STOP_CTRLC',
    'XPRS_STOP_GENERICERROR',
    'XPRS_STOP_ITERLIMIT',
    'XPRS_STOP_LICENSELOST',
    'XPRS_STOP_MEMORYERROR',
    'XPRS_STOP_MIPGAP',
    'XPRS_STOP_NODELIMIT',
    'XPRS_STOP_NONE',
    'XPRS_STOP_NUMERICALERROR',
    'XPRS_STOP_SOLLIMIT',
    'XPRS_STOP_SOLVECOMPLETE',
    'XPRS_STOP_TIMELIMIT',
    'XPRS_STOP_USER',
    'XPRS_TUNE',
    'XPRS_UBND',
    'XPRS_UCOST',
    'XPRS_UDN',
    'XPRS_UNB',
    'XPRS_UNF',
    'XPRS_UP',
    'XPRS_UPACT',
    'XPRS_UUP',
    'xps3authorizationheader',
    'xps3canonicalrequest',
    'xps3ci5indmp',
    'xps3clearerror',
    'xps3credentialspolicies',
    'xps3credentialsrequest',
    'xps3datestring',
    'xps3decodequerystring',
    'xps3formatquerystring',
    'xps3geterror',
    'xps3geterrormsg',
    'xps3gethttphost',
    'xps3hmacsha256',
    'xps3httpbucketlistrequest',
    'xps3httpheader',
    'xps3httpobjectrequest',
    'xps3implode',
    'xps3initfromdmpmanager',
    'xps3internalerror',
    'xps3isretryableresponse',
    'xps3lockbucket',
    'xps3log',
    'xps3parseerrorcode',
    'xps3parseerrorresponse',
    'xps3parsehttpheaders',
    'xps3parseobjectmetadata',
    'xps3posthttp',
    'xps3prehttp',
    'xps3requestend',
    'xps3requeststart',
    'xps3seterror',
    'xps3sha256',
    'xps3signature',
    'xps3stringtosign',
    'xps3timestamp',
    'xps3timestampstring',
    'xps3uriencode',
    'xps3urldecode',
    'xps3writehttpheaders',
    'ziplist',
    '_',
]
#
#
#
APPRUNNER_LOCAL_VARIABLES = [
    'appRunnerEntity',
    'AppRunnerEntityId',
    'AppRunnerEntityFilter',
    'AppRunnerModelEntities',
    'AppRunnerScalarBoolean',
    'AppRunnerScalarInteger',
    'AppRunnerScalarReal',
    'AppRunnerScalarString'
    'AppRunnerTransferType',
    'errorIfMissing',
    'entityTablePath'
]

#
MOSEL_KEYWORDS = set(MOSEL_RESERVED_WORDS + APPRUNNER_GLOBAL_DICTIONARY + APPRUNNER_LOCAL_VARIABLES)
#
#
MOSEL_KEYWORDS.update([word.upper() for word in MOSEL_RESERVED_WORDS])
